/*
	Autor : Kamil 'Drazek' Drkiewicz 
	Unit1.pl
*/

#include <iostream>
#include <string>

using namespace std;

const int ITEMS = 4;
const int WORDS = 3;

// nasze cudowne zdanie nieco zmienione :)
unsigned text[ITEMS] = { 
					 144202216,	// "Hel"
				  	 21622264,	// "lo "
					 238222228,	// "wor"
					 216200		// "ld " 
				  };

// klucze
unsigned keys[ITEMS][WORDS*2] = {  {0, 2, 2, 3, 5, 3}, {0, 3, 3, 3, 6, 3},
							  {0, 3, 3, 3, 6, 3}, {0, 3, 3, 3, 0, 0} };

string IntToStr(const unsigned& value)
{
	string temp;
	char result[256];
	sprintf(result,"%.i", value); 
	temp = result;
	return temp;
}

void moveBitsLeft(unsigned *ptr)
{
	while(*ptr)
	{
		*ptr = *ptr >> 1;
		ptr++;
	}
}

// dzielimy liczbe na kody ASCII
void getPart(unsigned* source, unsigned* temp, unsigned* sets, const int& level)
{
	// zamieniemy na liczbe
	string str = IntToStr(source[level]);
	 
	// wycinamy pierwsza litere
	string sp1 = str.substr(sets[(WORDS*2)-6], sets[(WORDS*2)-5]);
	temp[0] = atoi(sp1.c_str());

	// wycinamy druga litere
	sp1 = str.substr(sets[(WORDS*2)-4], sets[(WORDS*2)-3]);
	temp[1] = atoi(sp1.c_str());

	// wycinamy trzecia litere
	sp1 = str.substr(sets[(WORDS*2)-2], sets[(WORDS*2)-1]);
	temp[2] = atoi(sp1.c_str());
}

// zamieniemy kod klawisza na char
string getString(unsigned *tab) 
{
	string temp;

	for(int i = 0; i < WORDS; i++)
	{
		// zamieniemy na char
		temp += static_cast<char>(tab[i]);
	}

	return temp;
}

// funkcja do wciagania naszego zdania
string getHelloWorld(unsigned *ptr)
{
	string temp = "";
	unsigned ipart[3];
	
	moveBitsLeft(ptr);	// przesowamy bity na odpowiadnia pozycje
	
	for (int i = 0; i < ITEMS; i++)
	{
		getPart(ptr, ipart, keys[i], i);	// dzielimy na czesci
		temp += getString(ipart);			// zamieniamy na string
	}

	return temp;
}


int main()
{
	cout << getHelloWorld(text) << endl;

	return 0;
}